> For the complete documentation index, see [llms.txt](https://docs.fira.money/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fira.money/resources/contracts-addresses.md).

# Contracts & Addresses

## Ethereum Mainnet Deployments

All smart contracts are deployed on Ethereum mainnet with verified source code. Contract ownership is assigned to designated multisig addresses for operational security.

### Core Protocol Addresses

| Role                     | Address                                      |
| ------------------------ | -------------------------------------------- |
| Deployer                 | `0x7Da82CBD315923d75dbb2C62F099392705FF97f9` |
| Treasury / Fee Recipient | `0x97fD565B913b439Ff16774Da152B1f71F05A82F1` |

## Core Contracts

### Lending Markets

| Contract                | Address                                      |
| ----------------------- | -------------------------------------------- |
| Variable LendingMarket  | `0xc8Db629192a96D6840e88a8451F17655880A2e4D` |
| Fixed FiraLendingMarket | `0x280ddD897F39C33fEf1CbF863B386Cb9a8e53a0e` |
| AdaptiveCurveIRM        | `0x73C288826347af3718e6F09c2A24AaFDA77684cD` |

### Router

| Contract      | Address                                      |
| ------------- | -------------------------------------------- |
| FiraRouterV4  | `0xFF615E63aAF2d1B1EE4AdFD34a5840747185d8A0` |
| ActionStorage | `0x0386685eA7d37c61dDb8F2e2E8c45f6a81d4A3C8` |

## Vaults

### Markov USDC Prime

| Field         | Value                                        |
| ------------- | -------------------------------------------- |
| Vault         | `0x50791a5cA041b9D6Dd03e64E3Fa0e34a376759AC` |
| Vault Factory | `0xe77E0f97A864558e5513209323e4169FcEAC6981` |
| Name          | Markov USDC Prime                            |
| Symbol        | mkUSDC                                       |
| Allocator     | `0x4E700A14868620a9Bba0669721F1945c410c7571` |
| Curator       | `0xc02B0D1ca7B986E63cf1599F9c32e8A96c2D4Cff` |
| Fee Recipient | `0x97fD565B913b439Ff16774Da152B1f71F05A82F1` |

## Token Contracts

### Wrapped Collateral Token

| Field                  | Value                                        |
| ---------------------- | -------------------------------------------- |
| Token                  | `0x62F5366C9E21A95326C461a098a408e034e017b3` |
| Name                   | Fira Wrapped USDC                            |
| Symbol                 | FW-USDC                                      |
| Rehypothecation Module | `0xad332515d9c82438BBa0e9FAA9486B52A33a7Ac8` |

## Factories

| Factory                  | Address                                      |
| ------------------------ | -------------------------------------------- |
| YieldContractFactory     | `0xcdB83Abb9121c04589567A4106C3cFaf65DB68Be` |
| FiraMarketFactory        | `0xBF1EfC2199ae9EE1B6f5060a45D4440157E49744` |
| ChainlinkOracleV2Factory | `0x7783fF7bE856C7A82bC5497Fb3CC8F7E8802D8dC` |

## Modules

| Module                | Address                                      |
| --------------------- | -------------------------------------------- |
| RehypothecationModule | `0xad332515d9c82438BBa0e9FAA9486B52A33a7Ac8` |
| LiquidityInjector     | `0x2104f638a839Ca7260180d9Ee7f4865C92Df4cE5` |

## Oracles

| Oracle       | Address                                      |
| ------------ | -------------------------------------------- |
| cbBTC / USDC | `0x698253A24CC4926090f841B38D31d6342A00a82C` |
| BCLpOracle   | `0xfEAAEC9124FB007d7c44Ed704A08d24b264de921` |
| bUSD0 UZR    | `0x30Da78355FcEA04D1fa34AF3c318BE203C6F2145` |

## UZR Market

Usual Zero Rate (UZR) — fixed-rate borrowing of USD0 against bUSD0 collateral. Deployed via UIP-18.

| Contract                | Address                                      |
| ----------------------- | -------------------------------------------- |
| UZR Lending Market      | `0xa428723eE8ffD87088C36121d72100B43F11fb6A` |
| Fixed Rate IRM (10 bps) | `0xdfCF197B0B65066183b04B88d50ACDC0C4b01385` |
| USL Helper Migrator     | `0x809C212b710f5b8E3F9898213f0D845E2Bc46EC2` |

| Parameter        | Value                                                |
| ---------------- | ---------------------------------------------------- |
| Loan Token       | USD0 (`0x73A15FeD60Bf67631dC6cd7Bc5B6e8da8190aCF5`)  |
| Collateral Token | bUSD0 (`0x35D8949372D46B7a3D5A56006AE77B215fc69bC0`) |
| LTV              | 88%                                                  |
| Base Rate        | 0%                                                   |
| Protocol Fee     | 0.10% APR                                            |

## Variable Rate Markets

### wstETH / USDC

Market ID

```
0xb3152ac00687cc9502b78ab452956f85cc89ac210deefda5dbff09f7f167b544
```

| Parameter        | Value                                        |
| ---------------- | -------------------------------------------- |
| LendingMarket    | `0xc8Db629192a96D6840e88a8451F17655880A2e4D` |
| Loan Token       | `0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48` |
| Collateral Token | `0x7f39C581F595B53c5cb19bD0b3f8dA6c935E2Ca0` |
| Oracle           | `0x48F7E36EB6B826B2dF4B2E630B62Cd25e89E40e2` |
| IRM              | `0x73C288826347af3718e6F09c2A24AaFDA77684cD` |
| LTV              | 87%                                          |
| LLTV             | 89%                                          |

### cbBTC / USDC

Market ID

```
0x39d3bdd30bf4bcf4a4d3547f2484abe1e30a2dcd41ed83788b40e2720357ab76
```

| Parameter        | Value                                        |
| ---------------- | -------------------------------------------- |
| LendingMarket    | `0xc8Db629192a96D6840e88a8451F17655880A2e4D` |
| Loan Token       | `0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48` |
| Collateral Token | `0xcbB7C0000aB88B473b1f5aFd9ef808440eed33Bf` |
| Oracle           | `0x698253A24CC4926090f841B38D31d6342A00a82C` |
| IRM              | `0x73C288826347af3718e6F09c2A24AaFDA77684cD` |
| LTV              | 88%                                          |
| LLTV             | 90%                                          |

## Market ID Verification

Market IDs are computed deterministically using:

```solidity
bytes32 id = keccak256(
abi.encode(
    loanToken,
    collateralToken,
    oracle,
    irm,
    ltv,
    lltv,
    whitelist
));
```

Users can reproduce this calculation using Foundry (chisel) or other Solidity tooling to verify market identifiers.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.fira.money/resources/contracts-addresses.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
